t / test-lib.shon commit Merge branch 'tf/string-list-init' (6b5005c)
   1#!/bin/sh
   2#
   3# Copyright (c) 2005 Junio C Hamano
   4#
   5# This program is free software: you can redistribute it and/or modify
   6# it under the terms of the GNU General Public License as published by
   7# the Free Software Foundation, either version 2 of the License, or
   8# (at your option) any later version.
   9#
  10# This program is distributed in the hope that it will be useful,
  11# but WITHOUT ANY WARRANTY; without even the implied warranty of
  12# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  13# GNU General Public License for more details.
  14#
  15# You should have received a copy of the GNU General Public License
  16# along with this program.  If not, see http://www.gnu.org/licenses/ .
  17
  18# if --tee was passed, write the output not only to the terminal, but
  19# additionally to the file test-results/$BASENAME.out, too.
  20case "$GIT_TEST_TEE_STARTED, $* " in
  21done,*)
  22        # do not redirect again
  23        ;;
  24*' --tee '*|*' --va'*)
  25        mkdir -p test-results
  26        BASE=test-results/$(basename "$0" .sh)
  27        (GIT_TEST_TEE_STARTED=done ${SHELL-sh} "$0" "$@" 2>&1;
  28         echo $? > $BASE.exit) | tee $BASE.out
  29        test "$(cat $BASE.exit)" = 0
  30        exit
  31        ;;
  32esac
  33
  34# Keep the original TERM for say_color
  35ORIGINAL_TERM=$TERM
  36
  37# For repeatability, reset the environment to known value.
  38LANG=C
  39LC_ALL=C
  40PAGER=cat
  41TZ=UTC
  42TERM=dumb
  43export LANG LC_ALL PAGER TERM TZ
  44EDITOR=:
  45unset VISUAL
  46unset GIT_EDITOR
  47unset AUTHOR_DATE
  48unset AUTHOR_EMAIL
  49unset AUTHOR_NAME
  50unset COMMIT_AUTHOR_EMAIL
  51unset COMMIT_AUTHOR_NAME
  52unset EMAIL
  53unset GIT_ALTERNATE_OBJECT_DIRECTORIES
  54unset GIT_AUTHOR_DATE
  55GIT_AUTHOR_EMAIL=author@example.com
  56GIT_AUTHOR_NAME='A U Thor'
  57unset GIT_COMMITTER_DATE
  58GIT_COMMITTER_EMAIL=committer@example.com
  59GIT_COMMITTER_NAME='C O Mitter'
  60unset GIT_DIFF_OPTS
  61unset GIT_DIR
  62unset GIT_WORK_TREE
  63unset GIT_EXTERNAL_DIFF
  64unset GIT_INDEX_FILE
  65unset GIT_OBJECT_DIRECTORY
  66unset GIT_CEILING_DIRECTORIES
  67unset SHA1_FILE_DIRECTORIES
  68unset SHA1_FILE_DIRECTORY
  69unset GIT_NOTES_REF
  70unset GIT_NOTES_DISPLAY_REF
  71unset GIT_NOTES_REWRITE_REF
  72unset GIT_NOTES_REWRITE_MODE
  73GIT_MERGE_VERBOSITY=5
  74export GIT_MERGE_VERBOSITY
  75export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
  76export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
  77export EDITOR
  78
  79# Protect ourselves from common misconfiguration to export
  80# CDPATH into the environment
  81unset CDPATH
  82
  83unset GREP_OPTIONS
  84
  85case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
  86        1|2|true)
  87                echo "* warning: Some tests will not work if GIT_TRACE" \
  88                        "is set as to trace on STDERR ! *"
  89                echo "* warning: Please set GIT_TRACE to something" \
  90                        "other than 1, 2 or true ! *"
  91                ;;
  92esac
  93
  94# Convenience
  95#
  96# A regexp to match 5 and 40 hexdigits
  97_x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
  98_x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
  99
 100# Each test should start with something like this, after copyright notices:
 101#
 102# test_description='Description of this test...
 103# This test checks if command xyzzy does the right thing...
 104# '
 105# . ./test-lib.sh
 106[ "x$ORIGINAL_TERM" != "xdumb" ] && (
 107                TERM=$ORIGINAL_TERM &&
 108                export TERM &&
 109                [ -t 1 ] &&
 110                tput bold >/dev/null 2>&1 &&
 111                tput setaf 1 >/dev/null 2>&1 &&
 112                tput sgr0 >/dev/null 2>&1
 113        ) &&
 114        color=t
 115
 116while test "$#" -ne 0
 117do
 118        case "$1" in
 119        -d|--d|--de|--deb|--debu|--debug)
 120                debug=t; shift ;;
 121        -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
 122                immediate=t; shift ;;
 123        -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
 124                GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
 125        -h|--h|--he|--hel|--help)
 126                help=t; shift ;;
 127        -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
 128                verbose=t; shift ;;
 129        -q|--q|--qu|--qui|--quie|--quiet)
 130                # Ignore --quiet under a TAP::Harness. Saying how many tests
 131                # passed without the ok/not ok details is always an error.
 132                test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
 133        --with-dashes)
 134                with_dashes=t; shift ;;
 135        --no-color)
 136                color=; shift ;;
 137        --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
 138                valgrind=t; verbose=t; shift ;;
 139        --tee)
 140                shift ;; # was handled already
 141        --root=*)
 142                root=$(expr "z$1" : 'z[^=]*=\(.*\)')
 143                shift ;;
 144        *)
 145                echo "error: unknown test option '$1'" >&2; exit 1 ;;
 146        esac
 147done
 148
 149if test -n "$color"; then
 150        say_color () {
 151                (
 152                TERM=$ORIGINAL_TERM
 153                export TERM
 154                case "$1" in
 155                        error) tput bold; tput setaf 1;; # bold red
 156                        skip)  tput bold; tput setaf 2;; # bold green
 157                        pass)  tput setaf 2;;            # green
 158                        info)  tput setaf 3;;            # brown
 159                        *) test -n "$quiet" && return;;
 160                esac
 161                shift
 162                printf "%s" "$*"
 163                tput sgr0
 164                echo
 165                )
 166        }
 167else
 168        say_color() {
 169                test -z "$1" && test -n "$quiet" && return
 170                shift
 171                echo "$*"
 172        }
 173fi
 174
 175error () {
 176        say_color error "error: $*"
 177        GIT_EXIT_OK=t
 178        exit 1
 179}
 180
 181say () {
 182        say_color info "$*"
 183}
 184
 185test "${test_description}" != "" ||
 186error "Test script did not set test_description."
 187
 188if test "$help" = "t"
 189then
 190        echo "$test_description"
 191        exit 0
 192fi
 193
 194exec 5>&1
 195if test "$verbose" = "t"
 196then
 197        exec 4>&2 3>&1
 198else
 199        exec 4>/dev/null 3>/dev/null
 200fi
 201
 202test_failure=0
 203test_count=0
 204test_fixed=0
 205test_broken=0
 206test_success=0
 207
 208test_external_has_tap=0
 209
 210die () {
 211        code=$?
 212        if test -n "$GIT_EXIT_OK"
 213        then
 214                exit $code
 215        else
 216                echo >&5 "FATAL: Unexpected exit with code $code"
 217                exit 1
 218        fi
 219}
 220
 221GIT_EXIT_OK=
 222trap 'die' EXIT
 223
 224# The semantics of the editor variables are that of invoking
 225# sh -c "$EDITOR \"$@\"" files ...
 226#
 227# If our trash directory contains shell metacharacters, they will be
 228# interpreted if we just set $EDITOR directly, so do a little dance with
 229# environment variables to work around this.
 230#
 231# In particular, quoting isn't enough, as the path may contain the same quote
 232# that we're using.
 233test_set_editor () {
 234        FAKE_EDITOR="$1"
 235        export FAKE_EDITOR
 236        EDITOR='"$FAKE_EDITOR"'
 237        export EDITOR
 238}
 239
 240test_decode_color () {
 241        sed     -e 's/.\[1m/<WHITE>/g' \
 242                -e 's/.\[31m/<RED>/g' \
 243                -e 's/.\[32m/<GREEN>/g' \
 244                -e 's/.\[33m/<YELLOW>/g' \
 245                -e 's/.\[34m/<BLUE>/g' \
 246                -e 's/.\[35m/<MAGENTA>/g' \
 247                -e 's/.\[36m/<CYAN>/g' \
 248                -e 's/.\[m/<RESET>/g'
 249}
 250
 251q_to_nul () {
 252        perl -pe 'y/Q/\000/'
 253}
 254
 255q_to_cr () {
 256        tr Q '\015'
 257}
 258
 259q_to_tab () {
 260        tr Q '\011'
 261}
 262
 263append_cr () {
 264        sed -e 's/$/Q/' | tr Q '\015'
 265}
 266
 267remove_cr () {
 268        tr '\015' Q | sed -e 's/Q$//'
 269}
 270
 271test_tick () {
 272        if test -z "${test_tick+set}"
 273        then
 274                test_tick=1112911993
 275        else
 276                test_tick=$(($test_tick + 60))
 277        fi
 278        GIT_COMMITTER_DATE="$test_tick -0700"
 279        GIT_AUTHOR_DATE="$test_tick -0700"
 280        export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
 281}
 282
 283# Call test_commit with the arguments "<message> [<file> [<contents>]]"
 284#
 285# This will commit a file with the given contents and the given commit
 286# message.  It will also add a tag with <message> as name.
 287#
 288# Both <file> and <contents> default to <message>.
 289
 290test_commit () {
 291        file=${2:-"$1.t"}
 292        echo "${3-$1}" > "$file" &&
 293        git add "$file" &&
 294        test_tick &&
 295        git commit -m "$1" &&
 296        git tag "$1"
 297}
 298
 299# Call test_merge with the arguments "<message> <commit>", where <commit>
 300# can be a tag pointing to the commit-to-merge.
 301
 302test_merge () {
 303        test_tick &&
 304        git merge -m "$1" "$2" &&
 305        git tag "$1"
 306}
 307
 308# This function helps systems where core.filemode=false is set.
 309# Use it instead of plain 'chmod +x' to set or unset the executable bit
 310# of a file in the working directory and add it to the index.
 311
 312test_chmod () {
 313        chmod "$@" &&
 314        git update-index --add "--chmod=$@"
 315}
 316
 317# Use test_set_prereq to tell that a particular prerequisite is available.
 318# The prerequisite can later be checked for in two ways:
 319#
 320# - Explicitly using test_have_prereq.
 321#
 322# - Implicitly by specifying the prerequisite tag in the calls to
 323#   test_expect_{success,failure,code}.
 324#
 325# The single parameter is the prerequisite tag (a simple word, in all
 326# capital letters by convention).
 327
 328test_set_prereq () {
 329        satisfied="$satisfied$1 "
 330}
 331satisfied=" "
 332
 333test_have_prereq () {
 334        case $satisfied in
 335        *" $1 "*)
 336                : yes, have it ;;
 337        *)
 338                ! : nope ;;
 339        esac
 340}
 341
 342# You are not expected to call test_ok_ and test_failure_ directly, use
 343# the text_expect_* functions instead.
 344
 345test_ok_ () {
 346        test_success=$(($test_success + 1))
 347        say_color "" "ok $test_count - $@"
 348}
 349
 350test_failure_ () {
 351        test_failure=$(($test_failure + 1))
 352        say_color error "not ok - $test_count $1"
 353        shift
 354        echo "$@" | sed -e 's/^/#       /'
 355        test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
 356}
 357
 358test_known_broken_ok_ () {
 359        test_fixed=$(($test_fixed+1))
 360        say_color "" "ok $test_count - $@ # TODO known breakage"
 361}
 362
 363test_known_broken_failure_ () {
 364        test_broken=$(($test_broken+1))
 365        say_color skip "not ok $test_count - $@ # TODO known breakage"
 366}
 367
 368test_debug () {
 369        test "$debug" = "" || eval "$1"
 370}
 371
 372test_run_ () {
 373        test_cleanup=:
 374        eval >&3 2>&4 "$1"
 375        eval_ret=$?
 376        eval >&3 2>&4 "$test_cleanup"
 377        if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"; then
 378                echo ""
 379        fi
 380        return 0
 381}
 382
 383test_skip () {
 384        test_count=$(($test_count+1))
 385        to_skip=
 386        for skp in $GIT_SKIP_TESTS
 387        do
 388                case $this_test.$test_count in
 389                $skp)
 390                        to_skip=t
 391                        break
 392                esac
 393        done
 394        if test -z "$to_skip" && test -n "$prereq" &&
 395           ! test_have_prereq "$prereq"
 396        then
 397                to_skip=t
 398        fi
 399        case "$to_skip" in
 400        t)
 401                say_color skip >&3 "skipping test: $@"
 402                say_color skip "ok $test_count # skip $1"
 403                : true
 404                ;;
 405        *)
 406                false
 407                ;;
 408        esac
 409}
 410
 411test_expect_failure () {
 412        test "$#" = 3 && { prereq=$1; shift; } || prereq=
 413        test "$#" = 2 ||
 414        error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
 415        if ! test_skip "$@"
 416        then
 417                say >&3 "checking known breakage: $2"
 418                test_run_ "$2"
 419                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 420                then
 421                        test_known_broken_ok_ "$1"
 422                else
 423                        test_known_broken_failure_ "$1"
 424                fi
 425        fi
 426        echo >&3 ""
 427}
 428
 429test_expect_success () {
 430        test "$#" = 3 && { prereq=$1; shift; } || prereq=
 431        test "$#" = 2 ||
 432        error "bug in the test script: not 2 or 3 parameters to test-expect-success"
 433        if ! test_skip "$@"
 434        then
 435                say >&3 "expecting success: $2"
 436                test_run_ "$2"
 437                if [ "$?" = 0 -a "$eval_ret" = 0 ]
 438                then
 439                        test_ok_ "$1"
 440                else
 441                        test_failure_ "$@"
 442                fi
 443        fi
 444        echo >&3 ""
 445}
 446
 447test_expect_code () {
 448        test "$#" = 4 && { prereq=$1; shift; } || prereq=
 449        test "$#" = 3 ||
 450        error "bug in the test script: not 3 or 4 parameters to test-expect-code"
 451        if ! test_skip "$@"
 452        then
 453                say >&3 "expecting exit code $1: $3"
 454                test_run_ "$3"
 455                if [ "$?" = 0 -a "$eval_ret" = "$1" ]
 456                then
 457                        test_ok_ "$2"
 458                else
 459                        test_failure_ "$@"
 460                fi
 461        fi
 462        echo >&3 ""
 463}
 464
 465# test_external runs external test scripts that provide continuous
 466# test output about their progress, and succeeds/fails on
 467# zero/non-zero exit code.  It outputs the test output on stdout even
 468# in non-verbose mode, and announces the external script with "# run
 469# <n>: ..." before running it.  When providing relative paths, keep in
 470# mind that all scripts run in "trash directory".
 471# Usage: test_external description command arguments...
 472# Example: test_external 'Perl API' perl ../path/to/test.pl
 473test_external () {
 474        test "$#" = 4 && { prereq=$1; shift; } || prereq=
 475        test "$#" = 3 ||
 476        error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
 477        descr="$1"
 478        shift
 479        if ! test_skip "$descr" "$@"
 480        then
 481                # Announce the script to reduce confusion about the
 482                # test output that follows.
 483                say_color "" "# run $test_count: $descr ($*)"
 484                # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
 485                # to be able to use them in script
 486                export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
 487                # Run command; redirect its stderr to &4 as in
 488                # test_run_, but keep its stdout on our stdout even in
 489                # non-verbose mode.
 490                "$@" 2>&4
 491                if [ "$?" = 0 ]
 492                then
 493                        if test $test_external_has_tap -eq 0; then
 494                                test_ok_ "$descr"
 495                        else
 496                                say_color "" "# test_external test $descr was ok"
 497                                test_success=$(($test_success + 1))
 498                        fi
 499                else
 500                        if test $test_external_has_tap -eq 0; then
 501                                test_failure_ "$descr" "$@"
 502                        else
 503                                say_color error "# test_external test $descr failed: $@"
 504                                test_failure=$(($test_failure + 1))
 505                        fi
 506                fi
 507        fi
 508}
 509
 510# Like test_external, but in addition tests that the command generated
 511# no output on stderr.
 512test_external_without_stderr () {
 513        # The temporary file has no (and must have no) security
 514        # implications.
 515        tmp="$TMPDIR"; if [ -z "$tmp" ]; then tmp=/tmp; fi
 516        stderr="$tmp/git-external-stderr.$$.tmp"
 517        test_external "$@" 4> "$stderr"
 518        [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
 519        descr="no stderr: $1"
 520        shift
 521        say >&3 "# expecting no stderr from previous command"
 522        if [ ! -s "$stderr" ]; then
 523                rm "$stderr"
 524
 525                if test $test_external_has_tap -eq 0; then
 526                        test_ok_ "$descr"
 527                else
 528                        say_color "" "# test_external_without_stderr test $descr was ok"
 529                        test_success=$(($test_success + 1))
 530                fi
 531        else
 532                if [ "$verbose" = t ]; then
 533                        output=`echo; echo "# Stderr is:"; cat "$stderr"`
 534                else
 535                        output=
 536                fi
 537                # rm first in case test_failure exits.
 538                rm "$stderr"
 539                if test $test_external_has_tap -eq 0; then
 540                        test_failure_ "$descr" "$@" "$output"
 541                else
 542                        say_color error "# test_external_without_stderr test $descr failed: $@: $output"
 543                        test_failure=$(($test_failure + 1))
 544                fi
 545        fi
 546}
 547
 548# This is not among top-level (test_expect_success | test_expect_failure)
 549# but is a prefix that can be used in the test script, like:
 550#
 551#       test_expect_success 'complain and die' '
 552#           do something &&
 553#           do something else &&
 554#           test_must_fail git checkout ../outerspace
 555#       '
 556#
 557# Writing this as "! git checkout ../outerspace" is wrong, because
 558# the failure could be due to a segv.  We want a controlled failure.
 559
 560test_must_fail () {
 561        "$@"
 562        test $? -gt 0 -a $? -le 129 -o $? -gt 192
 563}
 564
 565# Similar to test_must_fail, but tolerates success, too.  This is
 566# meant to be used in contexts like:
 567#
 568#       test_expect_success 'some command works without configuration' '
 569#               test_might_fail git config --unset all.configuration &&
 570#               do something
 571#       '
 572#
 573# Writing "git config --unset all.configuration || :" would be wrong,
 574# because we want to notice if it fails due to segv.
 575
 576test_might_fail () {
 577        "$@"
 578        test $? -ge 0 -a $? -le 129 -o $? -gt 192
 579}
 580
 581# test_cmp is a helper function to compare actual and expected output.
 582# You can use it like:
 583#
 584#       test_expect_success 'foo works' '
 585#               echo expected >expected &&
 586#               foo >actual &&
 587#               test_cmp expected actual
 588#       '
 589#
 590# This could be written as either "cmp" or "diff -u", but:
 591# - cmp's output is not nearly as easy to read as diff -u
 592# - not all diff versions understand "-u"
 593
 594test_cmp() {
 595        $GIT_TEST_CMP "$@"
 596}
 597
 598# This function can be used to schedule some commands to be run
 599# unconditionally at the end of the test to restore sanity:
 600#
 601#       test_expect_success 'test core.capslock' '
 602#               git config core.capslock true &&
 603#               test_when_finished "git config --unset core.capslock" &&
 604#               hello world
 605#       '
 606#
 607# That would be roughly equivalent to
 608#
 609#       test_expect_success 'test core.capslock' '
 610#               git config core.capslock true &&
 611#               hello world
 612#               git config --unset core.capslock
 613#       '
 614#
 615# except that the greeting and config --unset must both succeed for
 616# the test to pass.
 617
 618test_when_finished () {
 619        test_cleanup="{ $*
 620                } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
 621}
 622
 623# Most tests can use the created repository, but some may need to create more.
 624# Usage: test_create_repo <directory>
 625test_create_repo () {
 626        test "$#" = 1 ||
 627        error "bug in the test script: not 1 parameter to test-create-repo"
 628        owd=`pwd`
 629        repo="$1"
 630        mkdir -p "$repo"
 631        cd "$repo" || error "Cannot setup test environment"
 632        "$GIT_EXEC_PATH/git-init" "--template=$TEST_DIRECTORY/../templates/blt/" >&3 2>&4 ||
 633        error "cannot run git init -- have you built things yet?"
 634        mv .git/hooks .git/hooks-disabled
 635        cd "$owd"
 636}
 637
 638test_done () {
 639        GIT_EXIT_OK=t
 640        test_results_dir="$TEST_DIRECTORY/test-results"
 641        mkdir -p "$test_results_dir"
 642        test_results_path="$test_results_dir/${0%.sh}-$$.counts"
 643
 644        echo "total $test_count" >> $test_results_path
 645        echo "success $test_success" >> $test_results_path
 646        echo "fixed $test_fixed" >> $test_results_path
 647        echo "broken $test_broken" >> $test_results_path
 648        echo "failed $test_failure" >> $test_results_path
 649        echo "" >> $test_results_path
 650
 651        if test "$test_fixed" != 0
 652        then
 653                say_color pass "# fixed $test_fixed known breakage(s)"
 654        fi
 655        if test "$test_broken" != 0
 656        then
 657                say_color error "# still have $test_broken known breakage(s)"
 658                msg="remaining $(($test_count-$test_broken)) test(s)"
 659        else
 660                msg="$test_count test(s)"
 661        fi
 662        case "$test_failure" in
 663        0)
 664                # Maybe print SKIP message
 665                [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
 666
 667                if test $test_external_has_tap -eq 0; then
 668                        say_color pass "# passed all $msg"
 669                        say "1..$test_count$skip_all"
 670                fi
 671
 672                test -d "$remove_trash" &&
 673                cd "$(dirname "$remove_trash")" &&
 674                rm -rf "$(basename "$remove_trash")"
 675
 676                exit 0 ;;
 677
 678        *)
 679                if test $test_external_has_tap -eq 0; then
 680                        say_color error "# failed $test_failure among $msg"
 681                        say "1..$test_count"
 682                fi
 683
 684                exit 1 ;;
 685
 686        esac
 687}
 688
 689# Test the binaries we have just built.  The tests are kept in
 690# t/ subdirectory and are run in 'trash directory' subdirectory.
 691TEST_DIRECTORY=$(pwd)
 692if test -n "$valgrind"
 693then
 694        make_symlink () {
 695                test -h "$2" &&
 696                test "$1" = "$(readlink "$2")" || {
 697                        # be super paranoid
 698                        if mkdir "$2".lock
 699                        then
 700                                rm -f "$2" &&
 701                                ln -s "$1" "$2" &&
 702                                rm -r "$2".lock
 703                        else
 704                                while test -d "$2".lock
 705                                do
 706                                        say "Waiting for lock on $2."
 707                                        sleep 1
 708                                done
 709                        fi
 710                }
 711        }
 712
 713        make_valgrind_symlink () {
 714                # handle only executables
 715                test -x "$1" || return
 716
 717                base=$(basename "$1")
 718                symlink_target=$TEST_DIRECTORY/../$base
 719                # do not override scripts
 720                if test -x "$symlink_target" &&
 721                    test ! -d "$symlink_target" &&
 722                    test "#!" != "$(head -c 2 < "$symlink_target")"
 723                then
 724                        symlink_target=../valgrind.sh
 725                fi
 726                case "$base" in
 727                *.sh|*.perl)
 728                        symlink_target=../unprocessed-script
 729                esac
 730                # create the link, or replace it if it is out of date
 731                make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
 732        }
 733
 734        # override all git executables in TEST_DIRECTORY/..
 735        GIT_VALGRIND=$TEST_DIRECTORY/valgrind
 736        mkdir -p "$GIT_VALGRIND"/bin
 737        for file in $TEST_DIRECTORY/../git* $TEST_DIRECTORY/../test-*
 738        do
 739                make_valgrind_symlink $file
 740        done
 741        OLDIFS=$IFS
 742        IFS=:
 743        for path in $PATH
 744        do
 745                ls "$path"/git-* 2> /dev/null |
 746                while read file
 747                do
 748                        make_valgrind_symlink "$file"
 749                done
 750        done
 751        IFS=$OLDIFS
 752        PATH=$GIT_VALGRIND/bin:$PATH
 753        GIT_EXEC_PATH=$GIT_VALGRIND/bin
 754        export GIT_VALGRIND
 755elif test -n "$GIT_TEST_INSTALLED" ; then
 756        GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path)  ||
 757        error "Cannot run git from $GIT_TEST_INSTALLED."
 758        PATH=$GIT_TEST_INSTALLED:$TEST_DIRECTORY/..:$PATH
 759        GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
 760else # normal case, use ../bin-wrappers only unless $with_dashes:
 761        git_bin_dir="$TEST_DIRECTORY/../bin-wrappers"
 762        if ! test -x "$git_bin_dir/git" ; then
 763                if test -z "$with_dashes" ; then
 764                        say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
 765                fi
 766                with_dashes=t
 767        fi
 768        PATH="$git_bin_dir:$PATH"
 769        GIT_EXEC_PATH=$TEST_DIRECTORY/..
 770        if test -n "$with_dashes" ; then
 771                PATH="$TEST_DIRECTORY/..:$PATH"
 772        fi
 773fi
 774GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
 775unset GIT_CONFIG
 776GIT_CONFIG_NOSYSTEM=1
 777GIT_CONFIG_NOGLOBAL=1
 778export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
 779
 780. ../GIT-BUILD-OPTIONS
 781
 782if test -z "$GIT_TEST_CMP"
 783then
 784        if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
 785        then
 786                GIT_TEST_CMP="$DIFF -c"
 787        else
 788                GIT_TEST_CMP="$DIFF -u"
 789        fi
 790fi
 791
 792GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
 793export GITPERLLIB
 794test -d ../templates/blt || {
 795        error "You haven't built things yet, have you?"
 796}
 797
 798if test -z "$GIT_TEST_INSTALLED" && test -z "$NO_PYTHON"
 799then
 800        GITPYTHONLIB="$(pwd)/../git_remote_helpers/build/lib"
 801        export GITPYTHONLIB
 802        test -d ../git_remote_helpers/build || {
 803                error "You haven't built git_remote_helpers yet, have you?"
 804        }
 805fi
 806
 807if ! test -x ../test-chmtime; then
 808        echo >&2 'You need to build test-chmtime:'
 809        echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
 810        exit 1
 811fi
 812
 813# Test repository
 814test="trash directory.$(basename "$0" .sh)"
 815test -n "$root" && test="$root/$test"
 816case "$test" in
 817/*) TRASH_DIRECTORY="$test" ;;
 818 *) TRASH_DIRECTORY="$TEST_DIRECTORY/$test" ;;
 819esac
 820test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
 821rm -fr "$test" || {
 822        GIT_EXIT_OK=t
 823        echo >&5 "FATAL: Cannot prepare test area"
 824        exit 1
 825}
 826
 827test_create_repo "$test"
 828# Use -P to resolve symlinks in our working directory so that the cwd
 829# in subprocesses like git equals our $PWD (for pathname comparisons).
 830cd -P "$test" || exit 1
 831
 832this_test=${0##*/}
 833this_test=${this_test%%-*}
 834for skp in $GIT_SKIP_TESTS
 835do
 836        case "$this_test" in
 837        $skp)
 838                say_color skip >&3 "skipping test $this_test altogether"
 839                skip_all="skip all tests in $this_test"
 840                test_done
 841        esac
 842done
 843
 844# Provide an implementation of the 'yes' utility
 845yes () {
 846        if test $# = 0
 847        then
 848                y=y
 849        else
 850                y="$*"
 851        fi
 852
 853        while echo "$y"
 854        do
 855                :
 856        done
 857}
 858
 859# Fix some commands on Windows
 860case $(uname -s) in
 861*MINGW*)
 862        # Windows has its own (incompatible) sort and find
 863        sort () {
 864                /usr/bin/sort "$@"
 865        }
 866        find () {
 867                /usr/bin/find "$@"
 868        }
 869        sum () {
 870                md5sum "$@"
 871        }
 872        # git sees Windows-style pwd
 873        pwd () {
 874                builtin pwd -W
 875        }
 876        # no POSIX permissions
 877        # backslashes in pathspec are converted to '/'
 878        # exec does not inherit the PID
 879        ;;
 880*)
 881        test_set_prereq POSIXPERM
 882        test_set_prereq BSLASHPSPEC
 883        test_set_prereq EXECKEEPSPID
 884        ;;
 885esac
 886
 887test -z "$NO_PERL" && test_set_prereq PERL
 888test -z "$NO_PYTHON" && test_set_prereq PYTHON
 889
 890# test whether the filesystem supports symbolic links
 891ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
 892rm -f y